using System.Text.Json.Serialization;
using View_by_Distance.Shared.Models;

namespace View_by_Distance.Property.Models;

public class Closest
{

    protected readonly double? _Average;
    protected readonly int? _FaceLocationIndex;
    protected readonly bool? _IsWrongYear;
    protected readonly DateTime _MinimumDateTime;
    protected readonly PersonBirthday? _PersonBirthday;

    public double? Average => _Average;
    public int? FaceLocationIndex => _FaceLocationIndex;
    public bool? IsWrongYear => _IsWrongYear;
    public DateTime MinimumDateTime => _MinimumDateTime;
    public PersonBirthday? PersonBirthday => _PersonBirthday;

    [JsonConstructor]
    public Closest(double? average, int? faceLocationIndex, bool? isWrongYear, DateTime minimumDateTime, PersonBirthday? personBirthday)
    {
        _Average = average;
        _FaceLocationIndex = faceLocationIndex;
        _IsWrongYear = isWrongYear;
        _MinimumDateTime = minimumDateTime;
        _PersonBirthday = personBirthday;
    }

    public Closest(int? faceLocationIndex, DateTime minimumDateTime, bool? isWrongYear, PersonBirthday? personBirthday, double? average)
    {
        _Average = average;
        _FaceLocationIndex = faceLocationIndex;
        _IsWrongYear = isWrongYear;
        _MinimumDateTime = minimumDateTime;
        _PersonBirthday = personBirthday;
    }

}